function [exponential] = isExponential(trce)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Renewal test: test to see if the trace fits an exponential ON-OFF model
%%%% PREREQUISITE:
%%%%       (1) Test the trace for stationarity using stationaryCheck.m
%%%% INPUT:
%%%%       (1) The trace
%%%% OUTPUT: exponentail =1 if the trace is exponential, 0 otherwise
%%%% COPYRIGHT : Hung X. Nguyen, the University of Adelaide, Australia
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% Anderson_Darling test for exponential

%%% Computing Loss and Good Run Length
L=[];
NL=[];
SL=[];

i=1;

LR =0;
NLR=0;
while (i <= length(trce))
    if ((trce(i)==1)&(NLR>0))
        NLR=NLR+1;
    elseif  ((trce(i)==1)&(NLR==0))
        if (LR >0)
            L=[L LR];
        end
        LR=0;
        NLR=NLR+1;
    elseif ((trce(i)==0)&(LR>0))
        LR =LR+1;
    elseif ((trce(i)==0)&(LR==0))
        if (NLR>0)
            NL=[NL NLR];
        end
        NLR=0;
        LR=LR+1;
    end
    i=i+1;
end


if (length(L)<length(NL))
    NL=NL(1:length(L));
elseif (length(L)>length(NL))
    L=L(1:length(NL));
end

acceptL = AnDarexptest(L,0.05);
isExpL = [isExpL acceptL];


acceptNL = AnDarexptest(NL,0.05);
isExpNL = [isExpNL acceptNL];

exponential=min(isExpL,isExpNL);